# Generated by Django 3.2.15 on 2022-08-26 08:37

import django.db.models.deletion
from django.db import migrations, models


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        ("projects", "0017_alter_monthdb_critical"),
    ]

    operations = [
        migrations.CreateModel(
            name="CloudScansResultsDb",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("scan_id", models.UUIDField(blank=True)),
                ("rescan_id", models.TextField(blank=True, null=True)),
                ("date_time", models.DateTimeField(blank=True, null=True)),
                ("vuln_id", models.UUIDField(blank=True)),
                ("false_positive", models.TextField(blank=True, null=True)),
                ("severity_color", models.TextField(blank=True)),
                ("dup_hash", models.TextField(blank=True, null=True)),
                ("vuln_duplicate", models.TextField(blank=True, null=True)),
                ("false_positive_hash", models.TextField(blank=True, null=True)),
                ("vuln_status", models.TextField(blank=True, null=True)),
                ("jira_ticket", models.TextField(blank=True, null=True)),
                ("title", models.TextField(blank=True, null=True)),
                ("severity", models.TextField(blank=True, null=True)),
                ("description", models.TextField(blank=True, null=True)),
                ("references", models.TextField(blank=True, null=True)),
                ("resourceName", models.TextField(blank=True, null=True)),
                ("resourceId", models.TextField(blank=True, null=True)),
                ("cloudType", models.TextField(blank=True, null=True)),
                ("cloudAccountId", models.TextField(blank=True, null=True)),
                ("solution", models.TextField(blank=True)),
                ("scanner", models.TextField(blank=True)),
                ("note", models.TextField(blank=True, null=True)),
                ("updated_time", models.DateTimeField(auto_now=True, null=True)),
                (
                    "project",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="projects.projectdb",
                    ),
                ),
            ],
            options={
                "verbose_name_plural": "Cloud Scans Data",
                "db_table": "cloudscansresultsdb",
            },
        ),
        migrations.CreateModel(
            name="CloudScansDb",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("project_name", models.TextField(blank=True, null=True)),
                ("scan_id", models.UUIDField(blank=True)),
                ("rescan_id", models.TextField(blank=True, null=True)),
                ("scan_date", models.TextField(blank=True)),
                ("scan_status", models.TextField(blank=True)),
                ("total_vul", models.IntegerField(blank=True, null=True)),
                ("critical_vul", models.IntegerField(blank=True, null=True)),
                ("high_vul", models.IntegerField(blank=True, null=True)),
                ("medium_vul", models.IntegerField(blank=True, null=True)),
                ("low_vul", models.IntegerField(blank=True, null=True)),
                ("info_vul", models.IntegerField(blank=True, null=True)),
                ("date_time", models.DateTimeField(blank=True, null=True)),
                ("rescan", models.TextField(blank=True, null=True)),
                ("total_dup", models.TextField(blank=True, null=True)),
                ("scanner", models.CharField(max_length=256, null=True)),
                ("updated_time", models.DateTimeField(auto_now=True, null=True)),
                (
                    "project",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="projects.projectdb",
                    ),
                ),
            ],
            options={
                "verbose_name_plural": "Static Scans Db",
                "db_table": "cloudscansdb",
            },
        ),
    ]
