# Generated by Django 3.1.12 on 2021-07-19 14:31

import uuid

import django.db.models.deletion
from django.db import migrations, models


class Migration(migrations.Migration):
    dependencies = [
        ("projects", "0013_auto_20201010_1955"),
    ]

    operations = [
        migrations.CreateModel(
            name="MonthDb",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("month", models.TextField(blank=True, null=True)),
                ("high", models.IntegerField(blank=True, default=0)),
                ("medium", models.IntegerField(blank=True, default=0)),
                ("low", models.IntegerField(blank=True, default=0)),
                ("updated_time", models.DateTimeField(auto_now=True, null=True)),
            ],
            options={
                "verbose_name_plural": "Month Db",
                "db_table": "monthdb",
            },
        ),
        migrations.CreateModel(
            name="ProjectDb",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "uu_id",
                    models.UUIDField(default=uuid.uuid4, editable=False, unique=True),
                ),
                ("project_name", models.CharField(max_length=255)),
                ("project_start", models.TextField(blank=True)),
                ("project_end", models.TextField(blank=True)),
                ("project_owner", models.TextField(blank=True)),
                ("project_disc", models.TextField(blank=True)),
                ("project_status", models.TextField(blank=True)),
                ("date_time", models.DateTimeField(null=True)),
                ("total_vuln", models.IntegerField(blank=True, null=True)),
                ("total_high", models.IntegerField(blank=True, null=True)),
                ("total_medium", models.IntegerField(blank=True, null=True)),
                ("total_low", models.IntegerField(blank=True, null=True)),
                ("total_open", models.IntegerField(blank=True, null=True)),
                ("total_false", models.IntegerField(blank=True, null=True)),
                ("total_close", models.IntegerField(blank=True, null=True)),
                ("total_net", models.IntegerField(blank=True, null=True)),
                ("total_web", models.IntegerField(blank=True, null=True)),
                ("total_static", models.IntegerField(blank=True, null=True)),
                ("high_net", models.IntegerField(blank=True, null=True)),
                ("high_web", models.IntegerField(blank=True, null=True)),
                ("high_static", models.IntegerField(blank=True, null=True)),
                ("medium_net", models.IntegerField(blank=True, null=True)),
                ("medium_web", models.IntegerField(blank=True, null=True)),
                ("medium_static", models.IntegerField(blank=True, null=True)),
                ("low_net", models.IntegerField(blank=True, null=True)),
                ("low_web", models.IntegerField(blank=True, null=True)),
                ("low_static", models.IntegerField(blank=True, null=True)),
                ("created_time", models.DateTimeField(auto_now_add=True)),
                ("updated_time", models.DateTimeField(auto_now=True, null=True)),
                ("is_active", models.BooleanField(default=True)),
            ],
            options={
                "verbose_name_plural": "Projects",
                "db_table": "project",
            },
        ),
        migrations.CreateModel(
            name="ProjectScanDb",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("project_url", models.TextField(blank=True)),
                ("project_ip", models.TextField(blank=True)),
                ("scan_type", models.TextField(blank=True)),
                ("date_time", models.DateTimeField(null=True)),
                ("updated_time", models.DateTimeField(auto_now=True, null=True)),
                (
                    "project",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="projects.projectdb",
                    ),
                ),
            ],
            options={
                "verbose_name_plural": "Project Scans Db",
                "db_table": "projectscandb",
            },
        ),
        migrations.DeleteModel(
            name="month_db",
        ),
        migrations.DeleteModel(
            name="project_db",
        ),
        migrations.DeleteModel(
            name="project_scan_db",
        ),
    ]
