# -*- coding: utf-8 -*-
#                    _
#     /\            | |
#    /  \   _ __ ___| |__   ___ _ __ _   _
#   / /\ \ | '__/ __| '_ \ / _ \ '__| | | |
#  / ____ \| | | (__| | | |  __/ |  | |_| |
# /_/    \_\_|  \___|_| |_|\___|_|   \__, |
#                                     __/ |
#                                    |___/
# Copyright (C) 2017 Anand Tiwari
#
# Email:   anandtiwarics@gmail.com
# Twitter: @anandtiwarics
#
# This file is part of ArcherySec Project.

from django.conf import settings
from django.conf.urls.static import static
from django.urls import include, path

from pentest import views

app_name = "pentest"

urlpatterns = [
    path("", views.PentestList.as_view(), name="list_scan"),
    path("add_vuln/", views.PentestVulnCreate.as_view(), name="add_vuln"),
    path("vuln_list/", views.PentestListVuln.as_view(), name="vuln_list"),
    path("edit_vuln/", views.EditPentestVuln.as_view(), name="edit_vuln"),
    path("manual_vuln_data/", views.PentestVulnData.as_view(), name="manual_vuln_data"),
    path("del_vuln/", views.PentestVulnDelete.as_view(), name="del_vuln"),
    path("del_scan/", views.PentestDelete.as_view(), name="del_scan"),
    path("vuln_details/", views.GetPentestVuln.as_view(), name="vuln_details"),
    path("add_list_scan/", views.PentestCreate.as_view(), name="add_list_scan"),
    path("add_vuln_data/", views.AddVulnData.as_view(), name="add_vuln_data"),
    path("add_new_vuln/", views.NewVulnCreate.as_view(), name="add_new_vuln"),
]
